From 4092191f7398a462db83a45540ed1022cd9ae58c Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 24 2020 04:44:48 +0000
Subject: [PATCH 1502/2232] Add static assertions on nature of Slice special member functions


---

diff --git a/src/cxx.cc b/src/cxx.cc
index 4000b26..923b641 100644
--- a/src/cxx.cc
+++ b/src/cxx.cc
@@ -169,6 +169,17 @@ static_assert(std::is_trivially_copy_assignable<Str>::value,
               "trivial operator=(const Str &)");
 static_assert(std::is_trivially_destructible<Str>::value, "trivial ~Str()");
 
+static_assert(std::is_trivially_copy_constructible<Slice<const uint8_t>>::value,
+              "trivial Slice(const Slice &)");
+static_assert(std::is_trivially_move_constructible<Slice<const uint8_t>>::value,
+              "trivial Slice(Slice &&)");
+static_assert(std::is_trivially_copy_assignable<Slice<const uint8_t>>::value,
+              "trivial Slice::operator=(const Slice &) for const slices");
+static_assert(std::is_trivially_move_assignable<Slice<const uint8_t>>::value,
+              "trivial Slice::operator=(Slice &&)");
+static_assert(std::is_trivially_destructible<Slice<const uint8_t>>::value,
+              "trivial ~Slice()");
+
 extern "C" {
 const char *cxxbridge1$error(const char *ptr, size_t len) {
   char *copy = new char[len];

